'From Squeak4.3 of 15 November 2012 [latest update: #12286] on 25 July 2014 at 5:14:38 pm'!
Morph subclass: #GroupMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Support'!
!GroupMorph commentStamp: 'jdr 4/18/2012 18:40' prior: 0!
A GroupMorph contains other morphs to move, rotate, etc... as a group

jdr 2012/04/18
!


!GroupMorph methodsFor: 'submorphs-add/remove' stamp: 'jdr 11/12/2012 14:12'!
dismissViaHalo
	"ungroup, delete o cancel,
	if ungroup move submorphs from me, then finish"

	| s ow |
	s := (UIManager default chooseFrom: {
					'Ungroup' translated.
					'Remove all' translated.
					'Cancel' translated.
				} title: 'Select for this group:' translated).
	s = 3 ifTrue: [^ self].
	s = 2 ifTrue:[^self dismissMorph].

	self owner isFlexMorph ifTrue:[
		|tm mtm|
		tm := self owner. 
		mtm := tm transform.
		ow := tm owner.
		self submorphsDo:[:m | |p mt|
			p := m  pointInWorld: (m center).
			ow addMorph: m.
			mt := m isFlexMorph ifTrue:[m] ifFalse:[m addFlexShell].
			mt angle: (mtm angle); scale: (mtm scale).
			mt center: p.
		]
	] 
	ifFalse:[
		ow := self owner.
		self submorphsDo:[:m| ow addMorph: m].
	].

	super dismissViaHalo.
! !


!GroupMorph methodsFor: 'initialization' stamp: 'jdr 4/18/2012 17:30'!
initialize

	super initialize.
	self color: Color transparent
! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

GroupMorph class
	instanceVariableNames: ''!

!GroupMorph class methodsFor: 'instance creation' stamp: 'jdr 4/18/2012 17:36'!
group: aCollectionOfMorphs
	"add aCollectionOfMorphs to me"

	| g |
	g := self new.
	g bounds: ((aCollectionOfMorphs at: 1) bounds).
	aCollectionOfMorphs allButFirstDo: [:m| g bounds: (g bounds merge: ( m bounds))].
	g addAllMorphs: aCollectionOfMorphs. 
	^g
! !


!GroupMorph class methodsFor: 'example-pie' stamp: 'jdr 1/9/2013 18:33'!
pie: pairs
	"pairs of {amount . color} "
	"|p| p := GroupMorph pie:  { {30 . Color red} . {55 . Color yellow} . {15 . Color blue}}.
		p openInHand "

	|amounts colors totals deg lastA slices g|
	amounts := pairs collect: [:ps| ps at: 1].
	colors := (pairs collect: [:ps| ps at: 2]) asOrderedCollection.
	totals := amounts sum.
	deg := amounts collect:[:a| (a / totals) * 360].
	lastA := 0.
	slices := OrderedCollection new.
	deg do: [:d| |s|
		s := self sliceFromAngle: lastA toAngle: lastA+d radius: 100 
			color: (colors removeFirst).
		slices add: s.
		lastA := lastA+d.
	].
	g := self group: slices.
	^g! !

!GroupMorph class methodsFor: 'example-pie' stamp: 'jdr 7/25/2014 17:08'!
sliceFromAngle: a1 toAngle: a2 radius: rad color: col
	"create slice of circle"
	" |s| s := GroupMorph sliceFromAngle: 30 toAngle: 60 radius: 100 color: Color red. 
	s openInHand "
	
	|ptC vert pm|
	ptC := [:a :r| r * ((a degreeCos) @ (a degreeSin))]. 
	vert := (a1 to: a2 by: 1) collect:[:a| ptC value: a value: rad].
	vert := vert asOrderedCollection.
	vert addAll: {0@0 . (ptC value: a1 value: rad)}.
	pm := CurvierMorph vertices: vert color: col borderWidth: 3 borderColor: (Color black).
	^pm

! !

!GroupMorph class methodsFor: 'example-pie' stamp: 'jdr 7/25/2014 17:14'!
sliceFromAngle: a1 toAngle: a2 radius: rad color: col fract: f
	"create slice of circle, version with f percent radio"
	" |s| s := GroupMorph sliceFromAngle: 30 toAngle: 60 radius: 100 color: Color red fract: 0.6.
	s openInHand "
	
	|ptC vert pm|
	ptC := [:a :r| r * ((a degreeCos) @ (a degreeSin))]. 
	vert := (a1 to: a2 by: 1) collect:[:a| ptC value: a value: rad].
	vert := vert asOrderedCollection.
	
	vert addAll: {(ptC value: a2 value: rad)*f . (ptC value: a1 value: rad)*f}.
	pm := CurvierMorph vertices: vert color: col borderWidth: 3 borderColor: (Color black).
	^pm

! !


!GroupMorph class methodsFor: 'aux' stamp: 'jdr 1/8/2013 15:44'!
altResistor
	"PolygonMorph resistor"
	" |r| r := GroupMorph altResistor. r openInHand "

	| pm v vert |
	v := {8@ -10 . 8@10}.
	vert := OrderedCollection new.
	vert addAll: {0@100 . 20@100}.
	0 to: 2 do:[:j| 
		v do:[:pt| vert add: ((vert last) + pt)].
	]. 
	vert add: ((vert last) + (20@0)).
	pm := PolygonMorph vertices: vert color: (Color blue) borderWidth: 3 borderColor: (Color 	black).
	pm makeOpen.
	^pm! !

!GroupMorph class methodsFor: 'aux' stamp: 'jdr 1/8/2013 17:46'!
arrow
	"small arrow"
	" |r| r := GroupMorph arrow. r openInHand "

	| pm2 vert |
	vert := {44@70 . 44@90 . 40@82 . 44@90 . 48@82}.
	pm2 := PolygonMorph vertices: vert color: (Color blue) borderWidth: 3 borderColor: (Color black).
	pm2 makeOpen.
	^pm2! !

!GroupMorph class methodsFor: 'aux' stamp: 'jdr 1/8/2013 17:11'!
curv
	"PolygonMorph segment of curve"
	" |r| r := GroupMorph curv. r openInHand "

	| pm vert |
	vert := {4@10 . 1@5.5 . 0@0 . 1@ -5.5 .4@ -10}.
	pm := CurvierMorph vertices: vert color: (Color blue) borderWidth: 3 borderColor: (Color black).
	pm left: 100; top: 100.
	pm makeOpen.
	^pm
! !

!GroupMorph class methodsFor: 'aux' stamp: 'jdr 1/8/2013 17:46'!
diode
	"PolygonMorph diode"
	" |r| r := GroupMorph diode. r openInHand "

	| pm vert |
	vert := OrderedCollection new.
	vert addAll: {0@100 . 30@100 . 30@90 . 30@ 110 . 50@100 . 30@90 . 50@100 . 50@90 . 50@ 110 . 50@100 . 80@100}.
	pm := PolygonMorph vertices: vert color: (Color blue) borderWidth: 3 borderColor: (Color black).
	pm makeOpen.
	^pm! !

!GroupMorph class methodsFor: 'aux' stamp: 'jdr 1/9/2013 17:58'!
inductor
	"PolygonMorph inductor"
	" |r| r := GroupMorph inductor. r openInHand "

	| pm ptC vert |
	ptC := [:a :r :d| r * ((1 - (a degreeCos) + d + 2) @ (a degreeSin))].
	vert := OrderedCollection new.
	vert addAll: {0@0 . 20@0}.
	(0 to: 2) do:[:j|
		vert addAll: ((0 to: 180 by: 9) collect:[:a| ptC value: a value: 10 value: (j*2)]).
	].
	vert addAll: {80@0 . 100@0}.

	pm := PolygonMorph vertices: vert color: (Color blue) borderWidth: 3 borderColor: (Color black).
	pm makeOpen.
	^pm! !

!GroupMorph class methodsFor: 'aux' stamp: 'jdr 1/8/2013 17:28'!
plus
	" two lines like a +"
	" |r| r := GroupMorph plus. r openInHand "

	| g linH linV |
	linH := LineMorph from: 7@93 to: 13@93 color: (Color black) width: 2.
	linV := LineMorph from: 10@90 to: 10@96 color: (Color black) width: 2.
	g := self group: {linH . linV}.
	^g! !

!GroupMorph class methodsFor: 'aux' stamp: 'jdr 1/8/2013 15:45'!
resistor
	"base PolygonMorph resistor"
	" |r| r := GroupMorph resistor. r openInHand "

	| pm v vert |
	v := {4@ -10 . 8@20 . 4@ -10}.
	vert := OrderedCollection new.
	vert addAll: {0@100 . 20@100}.
	0 to: 2 do:[:j| 
		v do:[:pt| vert add: ((vert last) + pt)].
	]. 
	vert add: ((vert last) + (20@0)).
	pm := PolygonMorph vertices: vert color: (Color blue) borderWidth: 3 borderColor: (Color black).
	pm makeOpen.
	^pm! !

!GroupMorph class methodsFor: 'aux' stamp: 'jdr 1/8/2013 16:11'!
t
	" two lines like a t"
	" |r| r := GroupMorph t. r openInHand "

	| pm vert |
	vert := OrderedCollection new.
	vert addAll: {100@0 . 100@ -20 . 90@ -20 . 110@ -20}.
	pm := PolygonMorph vertices: vert color: (Color blue) borderWidth: 3 borderColor: (Color black).
	pm makeOpen.

	^pm! !

!GroupMorph class methodsFor: 'aux' stamp: 'jdr 1/8/2013 18:32'!
wall
	"PolygonMorph wall"
	" |r| r := GroupMorph wall. r openInHand "

	| pm vert |
	vert := OrderedCollection new.
	vert addAll: {0@100 . 20@100 . 20@80 . 20@120}.
	pm := PolygonMorph vertices: vert color: (Color blue) borderWidth: 3 borderColor: (Color black).
	pm makeOpen. 
	^pm! !

!GroupMorph class methodsFor: 'aux' stamp: 'jdr 1/8/2013 17:45'!
zenerDiode
	"PolygonMorph zenerDiode"
	" |r| r := GroupMorph zenerDiode. r openInHand "

	| pm vert |
	vert := OrderedCollection new.
	vert addAll: {0@100 . 30@100 . 30@90 . 30@ 110 . 50@100 . 30@90 . 50@100 . 50@90 . 45@90 . 50@90 .50@ 110 . 55@110 . 50@110 . 50@100 . 80@100}.
	pm := PolygonMorph vertices: vert color: (Color blue) borderWidth: 3 borderColor: (Color black).
	pm makeOpen.
	^pm! !


!GroupMorph class methodsFor: 'examples-ee' stamp: 'jdr 1/8/2013 18:45'!
battery
	"wall + 2 lines + t"
	" |g| g := GroupMorph battery. g openInHand "

	| g wall lin1 lin2 t |
	wall := self wall.
	lin1 := LineMorph from: 30@90 to: 30@110 color: (Color black) width: 3.
	lin2 := LineMorph from: 40@80 to: 40@120 color: (Color black) width: 3.
	t := self t.
	t heading: -90; center: wall center; left: 50.
	g := self group: {wall . lin1 . lin2 . t}.
	^g! !

!GroupMorph class methodsFor: 'examples-ee' stamp: 'jdr 1/8/2013 16:14'!
capacitor
	"two t"
	" |g| g := GroupMorph capacitor. g openInHand "

	| t1 t2 g |
	t1 := self t.
	t2 := t1 copy.
	t2 heading: 180; top:  -50.
	g := self group: {t1 . t2}.
	^g! !

!GroupMorph class methodsFor: 'examples-ee' stamp: 'jdr 1/8/2013 18:49'!
crossWires
	"unconnected, 3 lines"
	" |g| g := GroupMorph crossWires. g openInHand "

	| g lin1 lin2 lin3 |
	lin1 := LineMorph from: 60@100 to: 80@100 color: (Color black) width: 3.
	lin2 := LineMorph from: 70@90 to: 70@95 color: (Color black) width: 3.
	lin3 := LineMorph from: 70@105 to: 70@110 color: (Color black) width: 3.
	g := self group: {lin1 . lin2 . lin3}.
	^g! !

!GroupMorph class methodsFor: 'examples-ee' stamp: 'jdr 1/8/2013 18:57'!
ground
	"t + 2 lines"
	" |g| g := GroupMorph ground. g openInHand "

	| g lin1 lin2 t |
	t := self t.
	t heading: 180; center: 70; bottom: 102.
	lin1 := LineMorph from: 64@104 to: 76@104 color: (Color black) width: 3.
	lin2 := LineMorph from: 68@108 to: 72@108 color: (Color black) width: 3.
	g := self group: {t . lin1 . lin2}.
	^g! !

!GroupMorph class methodsFor: 'examples-ee' stamp: 'jdr 1/8/2013 18:24'!
led
	"diode + 2 very small arrows"
	" |g| g := GroupMorph led. g openInHand "

	| g vert diode miniArrow1 miniArrow2 |
	diode := self diode.

	vert := OrderedCollection new.
	vert addAll: {60@110 . 70@120 . 70@115 . 70@120 . 65@120}.
	miniArrow1 := PolygonMorph vertices: vert color: (Color blue) borderWidth: 2 borderColor: (Color black).
	miniArrow1 makeOpen.
	miniArrow2 := miniArrow1 copy.
	miniArrow2 bottom: 117; right: 80.

	g := self group: {diode . miniArrow1 . miniArrow2}.
	^g! !

!GroupMorph class methodsFor: 'examples-ee' stamp: 'jdr 1/9/2013 18:09'!
opAmp
	"small arrow"
	" |r| r := GroupMorph opAmp. r openInHand "


	| delta g lin1 lin2 minus plus vert |
	vert := OrderedCollection new.
	vert addAll: {30@80 . 30@ 120 . 75@100 . 30@80}.
	delta := PolygonMorph vertices: vert color: (Color white) borderWidth: 3 borderColor: (Color black).
	plus := self plus.
	plus left: 36.
	minus := LineMorph from: 36@107 to: 42@107 color: (Color black) width: 2.

	lin1 := LineMorph from: 10@93 to: 30@93 color: (Color black) width: 2.
	lin2 := LineMorph from: 10@107 to: 30@107 color: (Color black) width: 2.


	g := self group:  { lin1. lin2 . plus . minus . delta}.
	^g! !

!GroupMorph class methodsFor: 'examples-ee' stamp: 'jdr 1/8/2013 17:43'!
polCapacitor
	"t + curv + plus + line"
	" |g| g := GroupMorph polCapacitor. g openInHand "

	| t c g plus lin |
	t := self t. 
	t heading: 90.
	c := self curv. 
	c center: t center; left: (t right)+3.
	plus := self plus.
	plus center: (t center)-6; left: (t left)+8.
	lin := LineMorph from:  28@100 to: 45@100 color: (Color black) width: 3.
	lin center: c center; left: (c left)+2.
	g := self group: {t . c . plus . lin}.
	^g! !

!GroupMorph class methodsFor: 'examples-ee' stamp: 'jdr 1/8/2013 15:56'!
potentiometer
	"altResistor + arrow"
	" |g| g := GroupMorph potentiometer. g openInHand "

	| g |
	g := self group: {self altResistor . self arrow}.
	^g! !

!GroupMorph class methodsFor: 'examples-ee' stamp: 'jdr 1/8/2013 18:34'!
transistorNPN
	"wall + arrow + line"
	" |g| g := GroupMorph transistorNPN. g openInHand "

	| arrow g lin wall |
	wall := self wall.

	arrow := self arrow.
	arrow heading: -60; left: (wall right)-1; top: wall bottom-10.

	lin := LineMorph from: 44@70 to: 44@90 color: (Color black) width: 3.
	lin heading: 60; left: (wall right)-1; bottom: wall top+10.

	g := self group: {wall . arrow . lin}.
	^g! !

!GroupMorph class methodsFor: 'examples-ee' stamp: 'jdr 1/8/2013 18:34'!
transistorPNP
	"wall + arrow + line"
	" |g| g := GroupMorph transistorPNP. g openInHand "

	| arrow g lin wall |
	wall := self wall.

	arrow := self arrow.
	arrow heading: 60; left: (wall right)-1; bottom: wall top+10.

	lin := LineMorph from: 44@70 to: 44@90 color: (Color black) width: 3.
	lin heading: -60; left: (wall right)-1; top: wall bottom-10.

	g := self group: {wall . arrow . lin}.
	^g! !
